/*
 * Created on Dec 19, 2003
 */
package com.ecyrd.jspwiki;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider;

/**
 * This is a hack. Shudder...  It's too late at night for this shit.
 * synchronized shit everywhere so we can hold an engine reference.
 * 
 * All this so the Visualizer can use the query plugin non-server-side.
 * 
 * @author jvolkar
 */
public class ReferenceManagerSpy implements ReferenceInfoProvider
{
    
    //todo: keyed on engine instance, okay to hold reference to an engine?
    private Map m_engineCacheMap = new HashMap();

    private WikiEngine m_engine;

    
    public ReferenceManagerSpy(WikiEngine engine)
    {
    	m_engine = engine;   
    }

    
    /* (non-Javadoc)
     * @see com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider#getRefersTo(java.lang.String)
     */
    public synchronized Collection getRefersTo(String page)
    {
        return (Collection)getRefersTo().get( page ) ;
    }

    /* (non-Javadoc)
     * @see com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider#getReferredBy(java.lang.String)
     */
    public synchronized Collection getReferredBy(String page)
    {
        return (Collection)getReferredBy().get( page ) ;
    }
    
    
    
    public synchronized Map getRefersTo()
    {
        MapCache cache = getCache( m_engine );
        return cache.getToMap( m_engine );
    }

    public synchronized Map getReferredBy()
    {
        MapCache cache = getCache( m_engine );
        return cache.getByMap( m_engine );
    }
    
    private MapCache getCache(WikiEngine engine)
    {
        MapCache cache = (MapCache)m_engineCacheMap.get( engine );
        
        if (null == cache)
        {
            cache = (MapCache)m_engineCacheMap.get( engine );
    
            if (null == cache)
            {    
                cache = new MapCache(engine);
                m_engineCacheMap.put( engine, cache );
            }
        }//if        
        
        return cache;
    }
    
    
    /**
     * Little utility class to handle To and By map caching for an engine instance.
     * 
     * Never holds reference to engine as I'm unsure what side-effects that might 
     * have. But duh the outer class does, so...  heck I'm not changing this now, 
     * no harm, no foul.
     * 
     * Outer must use the accessors get*() and not bypass to our private fields.
     * 
     * @author jvolkar
     */
    private static class MapCache
    {
        private long m_lastUpdate;
        private Map m_toMap;
        private Map m_byMap;
    
        private MapCache(WikiEngine engine)
        {
            updateCopies(engine);
        }
        
        private void updateCopies(WikiEngine engine)
        {
            ReferenceManager manager = engine.getReferenceManager();
        
            m_toMap = new HashMap( manager.getRefersTo() );
            m_byMap = new HashMap( manager.getReferredBy() );
            
            m_lastUpdate = System.currentTimeMillis();
        }
        
        private Map getToMap(WikiEngine engine)
        {
            updateIfNeeded(engine);
            return m_toMap;
        }
        
        private Map getByMap(WikiEngine engine)
        {
            updateIfNeeded(engine);
            return m_byMap;
        }
        
        
        private void updateIfNeeded(WikiEngine engine)
        {
            long now = System.currentTimeMillis();
            
            if ((now - m_lastUpdate ) > 15000)
                updateCopies( engine );
        }
        
    }
}
