package com.mckessonaps.jspwiki.ntauth;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import jcifs.UniAddress;
import jcifs.smb.NtlmPasswordAuthentication;
import jcifs.smb.SmbAuthException;
import jcifs.smb.SmbSession;

/**
 * This simplistic demo exercises some of hte bare bones feartures of jCIFS to show that we infact can
 * authenticate against a domain controller.
 * 
 * @author JVolkar
 */
public class JcifsDemo
{

    public static void main(String[] args)
    {
        try
        {
            BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

            System.out.println("Domain Controller?");
            String dcontoller = in.readLine();

            System.out.println("Domain Name?");
            String dname = in.readLine();

            System.out.println("Username?");
            String user = in.readLine();

            System.out.println("Password?");
            String pass = in.readLine();

            UniAddress domainController = UniAddress.getByName(dcontoller);

            NtlmPasswordAuthentication authentication =
                new NtlmPasswordAuthentication(dname, user, pass);

            SmbSession.logon(domainController, authentication);
  
            System.out.println("Sucessfully authenticated.");
        }
        catch (SmbAuthException sae)
        {
            System.out.println("Authentication failed.");
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}
