package com.mckessonaps.jspwiki.plugin.agregate;

import com.mckessonaps.jspwiki.plugin.util.BooleanParam;
import com.mckessonaps.jspwiki.plugin.util.IntParam;
import com.mckessonaps.jspwiki.plugin.util.ParameterGroup;
import com.mckessonaps.jspwiki.plugin.util.StringParam;

/**
 * Group all parameter information here in one lace where it's not lost amongst all the
 * real implematation code.
 * @author JVolkar
 */
class AggregateParamGroup extends ParameterGroup
{

    //For ourself...
    private static final String DESC_MAX_PAGES = "Limit the number of pages that emitted in the aggregated output.";
    final IntParam m_maxPages = new IntParam("maxpages", Integer.MAX_VALUE, false, DESC_MAX_PAGES, this);
    
    //For ourself...
    private static final String DESC_BACK_TO = "If non-blank, after each aggregated item a 'Back' link will be emitted."; 
    final StringParam m_backTo = new StringParam("backto", "", false, DESC_BACK_TO, this);
    
    //For ourself...
    private static final String DESC_ORDER = "How should aggregatd pages be ordered in the output.  One of 'alpha', 'reverseAlpha', 'ascendingModification', 'decendingModification'.  Default is 'alpha'betical order."; 
    final StringParam m_ordering = new StringParam("order", "alpha", false, DESC_ORDER, this);
    
    //For ourself...
    private static final String DESC_INDEX = "An index of the aggregated pages can be optionally generated.  One of 'none', 'list', or 'delim'.  Default is 'none'.  'list' generates a simple vertical list, 'delim' generates a comma delimited index."; 
    final StringParam m_indexKind = new StringParam("index", "none", false, DESC_INDEX, this);
    
    //For ourself...
    private static final String DESC_SEPARATOR = "Should a <HR /> separator be generated after each aggregated page.  'true' | 'false', default is 'false'."; 
    final BooleanParam m_emitSeparator = new BooleanParam("separator", false, false, DESC_SEPARATOR, this);
    

    //For QueryPlugin...
    private static final String DESC_PAGES = "Passed to a QueryPlugin instance, default query used is 'TO [CurrentPage]'. "; 
    final StringParam m_pages = new StringParam("pages", "", false, DESC_PAGES, this);

    //For InsertPage...
    private static final String DESC_SECTION = "Passed to a InsertPage instance, what section of the page should be aggregated."; 
    final IntParam m_section = new IntParam("section", -1, false, DESC_SECTION, this);
    
    //For InsertPage...
    private static final String DESC_MAX_LENGTH = "Passed to a InsertPage instance, limits the lenght of the inserted data."; 
    final IntParam m_maxlength = new IntParam("maxlen", Integer.MAX_VALUE, false, DESC_MAX_LENGTH, this);
    
    //For InsertPage...
    private static final String DESC_BODY_CLASS = "Passed to a InsertPage instance as it's 'class=' parameter. Defaults to 'aggregatorPageBody'."; 
    final StringParam m_bodyClass =  new StringParam("bodyclass", "aggregatedPageBody", false, DESC_BODY_CLASS, this);
    
    
    
    
    
}
