package com.mckessonaps.jspwiki.plugin.agregate;

import java.util.Comparator;

import com.ecyrd.jspwiki.WikiPage;

/**
 * Comparator for WikiPages based on the name of the page, results in normal A-Z 
 * alphabetical ordering.
 */
public class AlphaPageComparator implements Comparator
{

    /**
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public int compare(Object arg0, Object arg1)
    {
        WikiPage firstPage = (WikiPage)arg0;
        WikiPage otherPage = (WikiPage)arg1;

        if( firstPage == null || otherPage == null ) 
            return 0; // don't matter...

        return firstPage.getName().compareTo( otherPage.getName() );
    }

}
