package com.mckessonaps.jspwiki.plugin.agregate;

import java.util.Comparator;

/**
 * Comparitor for two WikiPages that does the comparisoon based on the last modified 
 * date to get a ascending sort.  e.g. Newest to Oldest like 2004, 2003, 1999 ...
 * @author JVolkar
 */
public class DescendingModificationPageComparator implements Comparator
{

    private static final AscendingModificationPageComparator ACENDING = new AscendingModificationPageComparator();
    
    
    /**
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public int compare(Object arg0, Object arg1)
    {
        //Just delegate to an Ascending comparitor with the args reversed...
        return ACENDING.compare( arg1, arg0);
    }

}
