package com.mckessonaps.jspwiki.plugin.agregate;

import java.util.Set;

import com.ecyrd.jspwiki.WikiEngine;
import com.mckessonaps.jspwiki.plugin.query.QueryPlugin;


/**
 * Subclass the QueryPlugin so we can hijack it's functionality...
 */
class QueryDelegate extends QueryPlugin
{
    private Set m_resultSet;

    
    /**
     * @return Null if execute hasn't yet been called, otherwise the set of pages
     * that satisfied the query.
     */
    Set getResultSet()
    {
        return m_resultSet;
    }
    
    
    /**
     * @see QueryPlugin#processResultSet(WikiEngine, Set)
     */
    protected String processResultSet(WikiEngine engine, Set resultSet)
    {
        //Capture the result set...
        //No need to copy the set, we create a LinkedList from it for our own use...
        m_resultSet = resultSet;

        //Cheesy, but the AggregatePlugin needs to know that it's safe to get
        //the result set from us, if the user specified a unparsable query then
        //the default behaviour of the QueryPlugin is to return a message.
        //On success return something unique so caller can know that everything 
        //went and usable results are available.
        return this.toString();

    }

}