/*
 * Created on Jan 26, 2004
 */
package com.mckessonaps.jspwiki.plugin.query;

import com.mckessonaps.jspwiki.plugin.query.operators.Modifier;

/**
 * An operand is anything capable of being evaluated to see if a canidate pagename 
 * shoudl be included in the query results.  Expressions and Terms are Operands.
 * 
 * @author jvolkar
 */
public interface Operand
{
    
    /**
     * Use as the leftExpression of uniary operators.
     * It is essentially empty and always answers "true".
     */
    public static final Operand NULL = new NullOperand();
    
    boolean evaluate(Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName);
    
    
    /**
     * Utility class, defined here for convenience. 
     * @author jvolkar
     */
    static class NullOperand
    implements Operand
    {
        /**
         * Hide this construtor.
         */
        private NullOperand() 
        {
            //nothing.
        }

        /**
         * Override to return empty string, a null operand has no representation.
         */
        public String toString()
        {
            return "";
        }
        
        /**
         * Override to always return true, always evaluates to true.
         */
        public boolean evaluate(Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName)
        {
            return true;
        }
        
    }
    
}
