/*
 * Created on Dec 22, 2003
 */
package com.mckessonaps.jspwiki.plugin.query;

import com.ecyrd.jspwiki.providers.ProviderException;
import com.mckessonaps.jspwiki.plugin.query.operators.Modifier;
import com.mckessonaps.jspwiki.plugin.query.operators.Operator;


/**
 * A Term is part of a Query's formal Expression that corresponds to a wiki page 
 * name.  A term of an expression evaluates to true if it matches the pagename 
 * begin evaluated.
 * 
 * @author jvolkar
 */
class Term
implements Operand
{
    
    private final String m_bracketedName;
    private String m_bareName;
    
    /**
     * Constructor, takes bracketed pageName.
     * @param pageName
     */
    Term(String pageName)
    {
        m_bracketedName = pageName;
        m_bareName = pageName.substring( 1, pageName.length() -1  );        
    }

    /**
     * Returns the bracketed pagename
     */
    public String toString()
    {
        return m_bracketedName;
    }
    
    /**
     * @see Operand
     */
    public boolean evaluate(Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName)
    {
        if (null == pageName) 
            return false;
        
        if (null == modifier) //If no modifer given, assume IS...
            modifier = (Modifier)Operator.IS; //dirty cast, ick...
        
        String canidateName = pageName;
        String termName = m_bareName;
        
        //todo: Handle plurals, ALIASes  Yikes!!!  
        //todo: Later allow user to enter Terms with spaces in them...
        
        if (null == canidateName) //attachments can cause the pageName to resolve to null...
            return false;
        
        return modifier.evaluate(refInfoProvider, canidateName, termName);
    }
}
