/*
 * Created on Jan 26, 2004
 */
package com.mckessonaps.jspwiki.plugin.query.operators;

import com.mckessonaps.jspwiki.plugin.query.Operand;
import com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider;

/**
 * @author jvolkar
 */
class AndOperator extends Operator
{
    AndOperator()
    {
        super("AND");
    }
    
    /**
     * Evaluates the left & right operands, returns the AND of them.
     * @see Operator#evaluate(Operand, Operand, Modifier, WikiEngine, String)
     */
    public boolean evaluate(Operand left, Operand right, Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName)
    {
        boolean lval = left.evaluate( modifier, refInfoProvider, pageName );
        boolean rval = right.evaluate( modifier, refInfoProvider, pageName );
        
        return (lval && rval);
    }
}
