/*
 * Created on Jan 27, 2004
 */
package com.mckessonaps.jspwiki.plugin.query.operators;

import com.mckessonaps.jspwiki.plugin.query.Operand;
import com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider;

/**
 * @see #evaluate(WikiEngine, String, String)
 * @author jvolkar
 */
public class IsOperator extends Operator implements Modifier
{
    IsOperator()
    {
        super("IS");
    }
    
    
    public boolean isInfix()
    {
        return false;
    }
    
  
    /**
     * The left operand is expected to be Operand.NULL, evaluate the right using this
     * as the modifier.
     * @see Operator#evaluate(Operand, Operand, Modifier, ReferenceInfoProvider, String)
     */
    public boolean evaluate(Operand left, Operand right, Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName)
    {
        if (left != Operand.NULL)
            throw new RuntimeException("IsOperator expects left operand to be the NULL operand.");

        //Ignore the passed modifier, and use ourself as new modifier...
        return right.evaluate( this, refInfoProvider, pageName );
    }

    /**
     * Evaluates to TRUE if canidateName IS termName.
     * @see Modifier#evaluate(WikiEngine, String, String)
     */
    public boolean evaluate(ReferenceInfoProvider refInfoProvider, String canidateName, String termName)
    {
        return canidateName.equalsIgnoreCase( termName );
    }

}
