/*
 * Created on Jan 26, 2004
 */
package com.mckessonaps.jspwiki.plugin.query.operators;

import com.mckessonaps.jspwiki.plugin.query.Operand;
import com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider;

/**
 * @author jvolkar
 */
class NullOperator extends Operator
{
    NullOperator()
    {
        super("");
    }
    
    public boolean evaluate(Operand left, Operand right, Modifier modifier, ReferenceInfoProvider  refInfoProvider, String pageName)
    {
        if ((Operand.NULL != left) && (Operand.NULL != right))
            throw new RuntimeException("A NullOperator with two good operands doesn't make sense.");

        //evaluate the non-null operand.  (we do both and AND it, becuase the NULL 
        //operand returns true, so it doesn't matter...
        boolean lval = left.evaluate( modifier, refInfoProvider, pageName );
        boolean rval = right.evaluate( modifier, refInfoProvider, pageName );
        return (lval && rval);
    }
}
