/*
 * Created on Dec 22, 2003
 */
package com.mckessonaps.jspwiki.plugin.query.operators;

import com.mckessonaps.jspwiki.plugin.query.Operand;
import com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider;

/**
 * @author jvolkar
 */
public abstract class Operator
{
    public static Operator NULL = new NullOperator();

    public static Operator AND = new AndOperator();
    public static Operator OR = new OrOperator();    
    public static Operator NOT = new NotOperator();
    
    public static Operator IS = new IsOperator();
    public static Operator TO = new ToOperator();    
    public static Operator BY = new ByOperator();
    
    
    private final String m_name;
    
    /**
     * Hide constructor from public, allow subclass access.
     * @param name
     */
    protected Operator(String name)
    {
        m_name = name;
    }
    
    public String toString()
    {
        return m_name;
    }

    public boolean isInfix()
    {
        return true;
    }
    
    public final boolean isPrefix()
    {
        return !isInfix();
    }
    
    public abstract boolean evaluate(Operand left, Operand right, Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName);
    
    
}
