/*
 * Created on Jan 26, 2004
 */
package com.mckessonaps.jspwiki.plugin.query.operators;

import java.util.Collection;

import com.mckessonaps.jspwiki.plugin.query.Operand;
import com.mckessonaps.jspwiki.plugin.query.ReferenceInfoProvider;

/**
 * @see #evaluate(WikiEngine, String, String)
 * @author jvolkar
 */
class ToOperator extends Operator implements Modifier
{
    ToOperator()
    {
        super("TO");
    }
    
    
    public boolean isInfix()
    {
        return false;
    }
    
  
    public boolean evaluate(Operand left, Operand right, Modifier modifier, ReferenceInfoProvider refInfoProvider, String pageName)
    {
        if (left != Operand.NULL)
            throw new RuntimeException("ToOperator expects left operand to be the NULL operand.");

        //Ignore the passed modifier, and use ourself as new modifier...
        return right.evaluate( this, refInfoProvider, pageName );
    }
    
    /**
     * Evaluates to TRUE if canidateName links to termName.
     * @see Modifier#evaluate(WikiEngine, String, String)
     */
    public boolean evaluate(ReferenceInfoProvider refInfoProvider, String canidateName, String termName)
    {
        Collection referers = refInfoProvider.getRefersTo( canidateName );
        
        if (null == referers)
            return false;
        
        return referers.contains( termName );
    }
    
}
