package com.mckessonaps.jspwiki.plugin.util;

/**
 * todo: javadoc BooleanParam
 * 
 * @author JVolkar
 */
public class BooleanParam extends Parameter
{

    private final boolean m_default;
    private boolean m_value;

    public BooleanParam(
        String name,
        boolean defaultValue,
        boolean required,
        String description,
        ParameterGroup group)
    {
        super(name, required, description, group);
        m_default = defaultValue;
    }

    protected void parseSuppliedValue()
    {
        boolean boolValue = false;
        boolValue |= getSuppliedValue().equalsIgnoreCase("true");
        boolValue |= getSuppliedValue().equalsIgnoreCase("on");
        boolValue |= getSuppliedValue().equalsIgnoreCase("yes");

        m_value = boolValue;
    }

    public boolean get()
    {
        if (usingDefault())
            return m_default;

        return m_value;
    }
    
    
    
}
