
package com.mckessonaps.jspwiki.plugin.util;

/**
 * todo: javadoc IntParam
 * @author JVolkar
 */
public class IntParam extends Parameter
{
    
    private final int m_default;
    private int m_value;
    
    public IntParam(String name, int defaultValue, boolean required, String description, ParameterGroup group)
    {
        super( name, required, description, group);
        m_default = defaultValue;
    }
    
    protected void parseSuppliedValue()
    throws ParameterException 
    {
        try
        {
            m_value = Integer.parseInt( getSuppliedValue() );
        }
        catch (NumberFormatException e)
        {
            throwBad( "Expected an integer.");
        }
        
    }
    
    public int get()
    {
        if (usingDefault())    
            return m_default;
        
        return m_value;
    }
}
