package com.mckessonaps.jspwiki.plugin.util;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * Serves as a container for a grouping of parameters. Future provisions for copying a group, buffering old
 * values, etc coudl come in as needed. Mostly right now this is a convenience clustering.
 */
public class ParameterGroup
{
    private final Set m_paramSet = new HashSet();

    public void add(Parameter p)
    {
        m_paramSet.add(p);
    }

    public void update(Map stringParamMap) throws ParameterException
    {
        for (Iterator iter = m_paramSet.iterator(); iter.hasNext();)
        {
            Parameter p = (Parameter) iter.next();
            p.update(stringParamMap);
        }
    }

}
