/*
 * Created on Dec 29, 2003
 */
package com.mckessonaps.jspwiki.plugin.visualizer;

import java.util.Map;

import com.ecyrd.jspwiki.WikiContext;
import com.ecyrd.jspwiki.plugin.WikiPlugin;
import com.mckessonaps.jspwiki.plugin.util.ParamUtil;

/**
 * @author jvolkar
 */
public class VisualizerPlugin 
implements WikiPlugin
{
    
    
    /**
     * Return and APPLET tag
     * @see com.ecyrd.jspwiki.plugin.WikiPlugin#execute(com.ecyrd.jspwiki.WikiContext, java.util.Map)
     */
    public String execute(WikiContext context, Map params)
    {
        if (noVisualizerAppletClass()) 
            return "Could not find VisualizerApplet class, the jar must be present in \\lib\\ and a public directory for the applet to be runnable.";
            
        String xmlrpcUrl = ParamUtil.getString(null, params, "xmlrpc", null);

        if (null == xmlrpcUrl)
            xmlrpcUrl = guessXmlRpcUrl(context);
        
        if (null == xmlrpcUrl) 
            return "You must provide the 'xmlrpc' parameter.";
        
        String unreferenced = getUnreferenced(params);
        
        StringBuffer buffer = new StringBuffer();
        buffer.append( "<APPLET ");
        buffer.append( "code=\"com.mckessonaps.visualizer.applet.VisualizerApplet.class\" " );
        buffer.append( "archive=\"Visualizer.jar\" ");
        buffer.append( "width=460 height=200 >\n");
        buffer.append( "<PARAM name=\"xmlrpc\" value=\"" + xmlrpcUrl + "\" >\n");
        buffer.append( "<PARAM name=\"unreferenced\" value=\"" + unreferenced + "\" >\n");
        buffer.append( "Sorry, but your browser doesn't support Java Applets.\n" );
        buffer.append( "</APPLET>" );
        return buffer.toString();
    }

    
    
    /**
     * @return TRUE if the visualizer jar is present on the class-path.
     */
    private boolean noVisualizerAppletClass()
    {
        boolean classMissing = true;
        try
        {
            Class.forName( "com.mckessonaps.visualizer.applet.VisualizerApplet" );
            classMissing = false;
        }
        catch (ClassNotFoundException e)
        {
            //ignore
        }
        return classMissing;
    }
    
    
    private String guessXmlRpcUrl(WikiContext context)
    {
        String baseUrl = context.getEngine().getBaseURL();
        
        if (null == baseUrl || "".equals( baseUrl ))
            return null;
        else
            return baseUrl + "/RPC2/";
    }

    
    private String getUnreferenced(Map params)
    {
        boolean value = ParamUtil.getBoolean( null, params, "unreferenced", false);
        
        return (value ? "true" : "false");
    }
    
}
